Attribute VB_Name = "Module1"
'RR32.BAS   24/7/00

DefInt A-T
DefSng U-Z

'For extracting system icons from EXE's & DLL's
Public Const MAX_PATH = 260
Public Const SHGFI_EXETYPE = &H2000       '  return exe & dll type
Public Const SHGFI_SYSICONINDEX = &H4000  '  get system icon index
Public Const SHGFI_LARGEICON = &H0        '  get large icon
Public Const SHGFI_SMALLICON = &H1        '  get small icon
Public Const SHGFI_SHELLICONSIZE = &H4    '  get shell size icon
Public Const SHGFI_TYPENAME = &H400       '  get type name
Public Const SHGFI_ICON = &H100           '  get icon handle
Public Const SHGFI_ICONLOCATION = &H1000  '  get icon location
Public Const SHGFI_DISPLAYNAME = &H200    '  get display name

Public Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" _
(ByVal pszPath As String, ByVal dwFileAttributes As Long, _
psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long

Public Type SHFILEINFO
        hIcon As Long                        '  out: icon
        iIcon As Long                        '  out: icon index
        dwAttributes As Long                 '  out: SFGAO_ flags
        szDisplayName As String * MAX_PATH   '  out: display name (or path)
        szTypeName As String * 80            '  out: type name
End Type
Public shinfo As SHFILEINFO

'Use:

'hSmall& = SHGetFileInfo(IconFileSpec$, 0&, shinfo, Len(shinfo), _
'BasicFlags Or SHGFI_SMALLICON)

'DrawIconEx picShow16.hdc, 0, 0, shinfo.hIcon, cw, ch, 0, 0, DI_IMAGE
'DestroyIcon shinfo.hIcon

'Public Const BasicFlags = SHGFI_TYPENAME Or SHGFI_SHELLICONSIZE _
'Or SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_EXETYPE Or SHGFI_ICON

Public Const BasicFlags = SHGFI_EXETYPE Or SHGFI_ICON

Public Declare Function DrawIconEx Lib "user32" _
    (ByVal hdc As Long, _
    ByVal xLeft As Long, ByVal yTop As Long, _
    ByVal hIcon As Long, _
    ByVal cxWidth As Long, ByVal cyWidth As Long, _
    ByVal istepIfAniCur As Long, _
    ByVal hbrFlickerFreeDraw As Long, _
    ByVal diFlags As Long) As Long

Public Declare Function DestroyIcon Lib "user32" _
    (ByVal hIcon As Long) As Long
    
Public Const DI_MASK = 1
Public Const DI_IMAGE = 2
Public Const DI_NORMAL = 3
Public Const DI_COMPAT = 4
Public Const DI_DEFAULTSIZE = 8
'------------------------------------------------------------------------------

'Copy one array to another of same number of bytes
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(Destination As Any, Source As Any, ByVal Length As Long)
'------------------------------------------------------------------------------

'Used to extract small bitmap from a large one and show shrunken bitmap
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, _
ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, _
ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

'------------------------------------------------------------------------------

'To get dimensions of GIF's & JPG's
Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" _
(ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
'------------------------------------------------------------------------------

'To shift cursor out of the way
Declare Sub SetCursorPos Lib "user32" (ByVal IX As Long, ByVal IY As Long)
'------------------------------------------------------------------------------

'Structres for Icons & Cursors
Public Type icocursignature
dres As Integer '0
dtyp As Integer '1 icon,  2 cursor
dnum As Integer 'num of icons
End Type
Global icocursig As icocursignature

Public Type icoinfo
iheight As Byte
iwidth As Byte
inumculs As Integer
inumplanes As Integer   'HotX for cursor
ibpp As Integer         'HotY for cursor
iresize As Long
ipointer As Long
End Type
Global icocurspec() As icoinfo
'------------------------------------------------------------------------------

'Bitmap header structures
Public Type BITMAPFILEHEADER
bfType As Integer
bfSize As Long
bfReserved1 As Integer
bfReserved2 As Integer
bfOffBits As Long
End Type
Global BitMapFile As BITMAPFILEHEADER

Public Type BITMAPINFOHEADER '40 bytes
biSize As Long
biWidth As Long
biHeight As Long
biPlanes As Integer
biBitCount As Integer
biCompression As Long
biSizeImage As Long
biXPelsPerMeter As Long
biYPelsPerMeter As Long
biClrUsed As Long
biClrImportant As Long
End Type
Global BitMapInf() As BITMAPINFOHEADER
'------------------------------------------------------------------------------

'Bitmap palette structure
Public Type RGBQUAD
rgbBlue As Byte
rgbGreen As Byte
rgbRed As Byte
rgbReserved As Byte
End Type
Global RGBI As RGBQUAD
'------------------------------------------------------------------------------

'For finding item in ListBox
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
       (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As _
       Integer, ByVal lParam As Any) As Long
Global Const LB_FINDSTRING = &H18F
'------------------------------------------------------------------------------

'For limiting text box to numeric data
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Const GWL_STYLE = (-16)
Public Const ES_NUMBER = &H2000&
'------------------------------------------------------------------------------

'Globals defined for this program
Global CurrentDirec$
Global IconDirec$, IconFileSpec$
Global CurDirec$, CurFileSpec$
Global BMPDirec$, PicFileSpec$
Global PalDirec$, Pal16FileSpec$, Pal32FileSpec$

Global Colors() As Long, svColors() As Long
Global NumColorsinPAL()
Global LeftCul16&, RightCul16&, cnleft16, cnright16
Global LeftCul32&, RightCul32&, cnleft32, cnright32
Global XOR16() As Byte, AND16() As Byte
Global XOR32() As Byte, AND32() As Byte
Global UndoMode, BlurrCount
Global svXOR16() As Byte, svAND16() As Byte
Global svXOR32() As Byte, svAND32() As Byte

Global pic16gridwidth, pic32gridwidth

Global op1(), op2() 'Used to save Options in case cancel

Global redc As Byte, greenc As Byte, bluec As Byte

Global IconParameter '1 16x16,  2 32x32,  3 16x16 & 32x32
'Set by Save icon menus

Global HotX, HotY 'Used by Cursor

Global TOOLINDEX                 'Used for drawing
Global sx, sy, ex, ey, DrawCul&  'Used for drawing

'Form2 for TransferActRectTopicShow32
Global MouseX, MouseY
Global LOADINPICWIDTH, LOADINPICHEIGHT


Public Sub CreateColors(n, MapOrBMPFile$, Index)
'Global Colors() As Long
'ReDim Colors(0 to 255, 1 to 2) As Long
'1 for pic16, 2 for pic32

'Get a 256 palette with colour numbers
'& fill the array Colors(0 to 255, 1 to 2)
On Error GoTo filenotfound
Select Case n
Case 1
   'Get a BMP palette
   If UCase$(Right$(MapOrBMPFile$, 3)) <> "BMP" Then Exit Sub

   Open MapOrBMPFile$ For Binary As #1
   posrow& = 55  'Start of palette bytes
   Seek #1, posrow&
   For n = 0 To 255
    B$ = Input$(1, 1): g$ = Input$(1, 1): r$ = Input$(1, 1)
    If B$ <> "" Then blu = Asc(B$) Else blu = 0
    If g$ <> "" Then grn = Asc(g$) Else grn = 0
    If r$ <> "" Then red = Asc(r$) Else red = 0
    Colors(n, Index) = RGB(red, grn, blu)
    d$ = Input$(1, 1)
   Next n
   Close #1
Case 2
   'Open Fractint *.map or PaintShopPro JASC PAL palette file
   Ext$ = UCase$(Right$(MapOrBMPFile$, 3))
   If Ext$ <> "MAP" And Ext$ <> "PAL" Then Exit Sub

   Open MapOrBMPFile$ For Input As #1
   Line Input #1, A$
   Close #1

   Open MapOrBMPFile$ For Input As #1

   p = InStr(1, A$, "JASC")
   If p <> 0 Then  'JASC-PAL MAP file
      'Skip the following 3 lines
      'JASC-PAL
      '0100
      '16 or 256
      Line Input #1, A$
      Line Input #1, A$
      Line Input #1, A$
   End If

   For n = 0 To 255
    If EOF(1) Then Exit For   'Allows < 256 colop palettes
    Line Input #1, A$
    ParseMAP A$, red, grn, blu
    Colors(n, Index) = RGB(red, grn, blu)
   Next n
   Close #1
   
   NumColorsinPAL(Index) = n

Case 3
   'Make a grey palette
   Num = 0
   For i = 0 To UBound(Colors)
    Colors(i, Index) = RGB(Num, Num, Num)
    Num = Num + 1
    If Num > 255 Then Num = 0
   Next i
   Close #1
End Select
'INSIST THAT Colors(0,1/2)=0 black
Colors(0, Index) = 0
Exit Sub
'===========
filenotfound:
Close
MsgBox ("Palette file error")
On Error GoTo 0
'----------------------------------
ChDrive Left$(CurrentDirec$, 1)
ChDir CurrentDirec$
'------------------------------------
'Make a grey palette
Num = 0
For i = 0 To UBound(Colors)
   Colors(i, Index) = RGB(Num, Num, Num)
   Num = Num + 1
   If Num > 255 Then Num = 0
Next i
'INSIST THAT Colors(0,1/2)=0 black
Colors(0, Index) = 0
If Index = 1 Then
    Form1.Lab16File.Caption = "Default 256 grey palette"
Else
    Form1.Lab32File.Caption = "Default 256 grey palette"
End If
Exit Sub
Resume
End Sub

Public Sub ParseMAP(ain$, red, grn, blu)
'Input string ain$, with 3 numbers(R G B) with
'space separators and then any text
ain$ = LTrim(ain$)
lena = Len(ain$)
r$ = ""
g$ = ""
B$ = ""
Num = 1 'R
For i = 1 To lena
   c$ = Mid$(ain$, i, 1)
   If c$ <> " " Then
      If Asc(c$) < 48 Or Asc(c$) > 57 Then Exit For
      If Num = 1 Then r$ = r$ + c$
      If Num = 2 Then g$ = g$ + c$
      If Num = 3 Then B$ = B$ + c$
   Else
      Num = Num + 1
      If Num = 4 Then Exit For
End If
Next i
red = Val(r$): grn = Val(g$): blu = Val(B$)
End Sub

Public Function ExtractFileName$(FSpec$)
ExtractFileName$ = " "
'In:  FSpec$ = Full FileSpec
'Out: FileName =ExtractFileName$
If FSpec$ = "" Then Exit Function
FileError = 0
'Find pbs on last backslash \
p = 0: pbs = 0
Do: p = InStr(p + 1, FSpec$, "\")
    If p <> 0 Then pbs = p Else Exit Do
Loop
If pbs > 0 Then
   ExtractFileName$ = Mid$(FSpec$, pbs + 1)
Else
   FileError = 1: Beep
End If
End Function
Public Function ExtractPath$(FSpec$)
ExtractPath$ = " "
'In:  FSpec$ = Full FileSpec
'Out: Path =ExtractPath$
If FSpec$ = "" Then Exit Function
FileError = 0
'Find pbs on last backslash \
p = 0: pbs = 0
Do: p = InStr(p + 1, FSpec$, "\")
    If p <> 0 Then pbs = p Else Exit Do
Loop
If pbs > 0 Then
   ExtractPath$ = Left$(FSpec$, pbs - 1)   'ie dropping last \
Else
   FileError = 1: Beep
End If
End Function

Public Sub CulToRGB(longcul&, RR$, GG$, BB$)
'Global redc As Byte, greenc As Byte, bluec As Byte
redc = longcul& And &HFF&
RR$ = Trim$(Str$(redc)): lenrgb = Len(RR$)
If lenrgb < 3 Then RR$ = String(3 - lenrgb, "0") + RR$
greenc = (longcul& And &HFF00&) / &H100&
GG$ = Trim$(Str$(greenc)): lenrgb = Len(GG$)
If lenrgb < 3 Then GG$ = String(3 - lenrgb, "0") + GG$
bluec = (longcul& And &HFF0000) / &H10000
BB$ = Trim$(Str$(bluec)): lenrgb = Len(BB$)
If lenrgb < 3 Then BB$ = String(3 - lenrgb, "0") + BB$
End Sub

Public Sub CulToRGBc(longcul&)
'Global redc As Byte, greenc As Byte, bluec As Byte
redc = longcul& And &HFF&
greenc = (longcul& And &HFF00&) / &H100&
bluec = (longcul& And &HFF0000) / &H10000
End Sub

Public Function GetCulNum(longcul&, n, cn)
'Input: Longcul&, n= 1 for 16 2 for 32 Output Colour number cn
For cn = 0 To 255
    If longcul& = Colors(cn, n) Then Exit For
Next cn
If cn = 256 Then cn = 255
GetCulNum = cn
End Function

Public Sub MAKEPAL16_XOR16()
'From cmdChoosePicLoad & ExtractFromEXE
'Make Colors(0,1) from picShow16 XOR
'& from picShow16 point colors move cn to XOR16()
'Extract 256 point culs,put into Colors(cn,1) & put cn in XOR16(i,j)
cn = 1
For j = 0 To 15
For i = 0 To 15
   cul& = Form1.picShow16.Point(i, j)
   'check if color already found
   For k = 0 To cn
     If cul& = Colors(k, 1) Then Exit For
   Next k
   If k = cn + 1 Then  'New color
      Colors(cn, 1) = cul&
      XOR16(i, j) = cn
      cn = cn + 1
      If cn > 255 Then cn = 255
   Else    'Existing color
      XOR16(i, j) = k
   End If
Next i
Next j
Colors(cn, 1) = 0 'Forced Black
Form1.FillpicPAL16
End Sub
Public Sub MAKEPAL32_XOR32()
'From cmdChoosePicLoad & ExtractFromEXE
'Make Colors(0,2) from picShow32 XOR
'& from picShow32 point colors move cn to XOR32()
'Extract 256 point culs,put into Colors(cn,2) & put cn in XOR32(i,j)
'Test if = prev cul to avoid some duplicationin Colors(cn,2)
cn = 1
For j = 0 To 31
For i = 0 To 31
   cul& = Form1.picShow32.Point(i, j)
   If cn = 255 Then  'Find best match of 256 colors already found
      CulToRGBc cul&
      redo = redc: greeno = greenc: blueo = bluec
      diffcul = 10000
      For mcn = 0 To 255
         CulToRGBc Colors(mcn, 2)
         'redc, greenc, bluec,bzero As Bytes
         diffc = Abs(redc - redo) + Abs(greenc - greeno) + Abs(bluec - blueo)
         If diffc < diffcul Then
            cnn = mcn
            diffcul = diffc
            If diffc = 0 Then Exit For
         End If
      Next mcn
      If mcm < 256 Then
         XOR32(i, j) = cnn
      Else
         XOR32(i, j) = 255
      End If
   Else
      'check if color already found
      For k = 0 To cn
         If cul& = Colors(k, 2) Then Exit For
      Next k
      If k = cn + 1 Then  'New color
         Colors(cn, 2) = cul&
         XOR32(i, j) = cn
         cn = cn + 1
         If cn = 254 Then
            MsgBox (">256 colors")
         End If
         If cn > 255 Then cn = 255
      Else    'Existing color
         XOR32(i, j) = k
      End If
   End If
Next i
Next j
Colors(cn, 2) = 0 'Forced Black
Form1.FillpicPAL32
End Sub
Public Sub MovepicShow16_AND16()
'From ExtractFromEXE
'picShow16 with AND Mask to AND16
For j = 0 To 15
For i = 0 To 15
    cul& = Form1.picShow16.Point(i, j)
    bit = 2 ^ (7 - (i Mod 8))
    If cul& <> 0 Then
       AND16(i \ 8, j) = AND16(i \ 8, j) Or bit 'i 0-7 8-15
    Else
       AND16(i \ 8, j) = AND16(i \ 8, j) And Not bit
    End If
Next i
Next j
Form1.TransferAND16topic16Icon
End Sub
Public Sub MovepicShow32_AND32()
'From ExtractFromEXE
'picShow32 with AND Mask to AND32
For j = 0 To 31
For i = 0 To 31
    cul& = Form1.picShow32.Point(i, j)
    bit = 2 ^ (7 - (i Mod 8))
    If cul& <> 0 Then
       AND32(i \ 8, j) = AND32(i \ 8, j) Or bit 'i 0-7 8-15
    Else
       AND32(i \ 8, j) = AND32(i \ 8, j) And Not bit
    End If
Next i
Next j
Form1.TransferAND32topic32Icon
End Sub

Public Sub InvertPalette(nicon)
Select Case nicon
Case 16
   For n = 1 To 255  'Does not invert 0 black
      CulToRGBc Colors(n, 1)  'redc,greenc,bluec
      Colors(n, 1) = RGB(255 - redc, 255 - greenc, 255 - bluec)
   Next n
   Form1.FillpicPAL16
Case 32
   For n = 1 To 255  'Does not invert 0 black
      CulToRGBc Colors(n, 2)  'redc,greenc,bluec
      Colors(n, 2) = RGB(255 - redc, 255 - greenc, 255 - bluec)
   Next n
   Form1.FillpicPAL32
End Select

End Sub

Public Sub SAVINGICONS(CIBFile$)
'NB Both 16x16 & 32x32 icons can be saved in all palettes
'apart from the 24-bit. ie 2,16 & 256 colors.

Dim bzero As Byte, abyte As Byte
Dim bits As String, nybs As String, bytes As String
Dim icotype16  As String, icotype32 As String

bits = "bits": nybs = "nybs": bytes = "byts"

'Get ICON Pal color range
icotype16 = bytes 'Assume Option1(6) True
If Form1.Option1(4) Then icotype16 = bits
If Form1.Option1(5) Then icotype16 = nybs
icotype32 = bytes 'Assume Option2(6) True
If Form1.Option2(4) Then icotype32 = bits
If Form1.Option2(5) Then icotype32 = nybs

Select Case icotype16
Case bits
    palsize16 = 8
    xorsize16 = 64
    andsize16 = 64
Case nybs
    palsize16 = 64
    xorsize16 = 128
    andsize16 = 64
Case bytes
    palsize16 = 1024
    xorsize16 = 256
    andsize16 = 64
End Select
Select Case icotype32
Case bits
    palsize32 = 8
    xorsize32 = 128
    andsize32 = 128
Case nybs
    palsize32 = 64
    xorsize32 = 512
    andsize32 = 128
Case bytes
    palsize32 = 1024
    xorsize32 = 1024
    andsize32 = 128
End Select

icocursig.dres = 0
icocursig.dtyp = 1
'Public Type icoinfo
'iheight As Byte
'iwidth As Byte
'inumculs As Integer
'inumplanes As Integer   'HotX for cursor
'ibpp As Integer     'HotY for cursor
'iresize As Long
'ipointer As Long
'End Type
'Global icocurspec() As icoinfo

'IconParameter 1 16x16,  2 32x32,  3 16x16 & 32x32
Select Case IconParameter
Case 1  '1 16x16
    icocursig.dnum = 1
    ReDim icocurspec(0)
    icocurspec(0).iheight = 16: icocurspec(0).iwidth = 16
    
    Select Case icotype16
    Case bits:  icocurspec(0).inumculs = 2:  icocurspec(0).ibpp = 1
    Case nybs:  icocurspec(0).inumculs = 16: icocurspec(0).ibpp = 4
    Case bytes: icocurspec(0).inumculs = 0:  icocurspec(0).ibpp = 8
    End Select
    
    icocurspec(0).inumplanes = 0
    icocurspec(0).iresize = 40 + palsize16 + xorsize16 + andsize16
    icocurspec(0).ipointer = 6 + 16
Case 2  '2 32x32
    icocursig.dnum = 1
    ReDim icocurspec(0)
    icocurspec(0).iheight = 32: icocurspec(0).iwidth = 32
    
    Select Case icotype32
    Case bits:  icocurspec(0).inumculs = 2:  icocurspec(0).ibpp = 1
    Case nybs:  icocurspec(0).inumculs = 16: icocurspec(0).ibpp = 4
    Case bytes: icocurspec(0).inumculs = 0:  icocurspec(0).ibpp = 8
    End Select
    
    icocurspec(0).inumplanes = 0
    icocurspec(0).iresize = 40 + palsize32 + xorsize32 + andsize32
    icocurspec(0).ipointer = 6 + 16
Case 3  '3 16x6 & 32x32
    icocursig.dnum = 2
    ReDim icocurspec(1)
    icocurspec(0).iheight = 16: icocurspec(0).iwidth = 16
    
    Select Case icotype16
    Case bits:  icocurspec(0).inumculs = 2:  icocurspec(0).ibpp = 1
    Case nybs:  icocurspec(0).inumculs = 16: icocurspec(0).ibpp = 4
    Case bytes: icocurspec(0).inumculs = 0:  icocurspec(0).ibpp = 8
    End Select
    
    icocurspec(0).inumplanes = 0
    icocurspec(0).iresize = 40 + palsize16 + xorsize16 + andsize16
    icocurspec(0).ipointer = 6 + 16 + 16 '38
    
    icocurspec(1).iheight = 32: icocurspec(1).iwidth = 32
    
    Select Case icotype32
    Case bits:  icocurspec(1).inumculs = 2:  icocurspec(1).ibpp = 1
    Case nybs:  icocurspec(1).inumculs = 16: icocurspec(1).ibpp = 4
    Case bytes: icocurspec(1).inumculs = 0:  icocurspec(1).ibpp = 8
    End Select
    
    icocurspec(1).inumplanes = 0
    icocurspec(1).iresize = 40 + palsize32 + xorsize32 + andsize32
    icocurspec(1).ipointer = icocurspec(0).ipointer + icocurspec(0).iresize
End Select

'Global BitMapInf() As BITMAPINFOHEADER
Select Case IconParameter
Case 1  '1 16x16
    ReDim BitMapInf(0)
    BitMapInf(0).biSize = 40
    BitMapInf(0).biWidth = 16
    BitMapInf(0).biHeight = 32
    BitMapInf(0).biPlanes = 1
    BitMapInf(0).biCompression = 0
    BitMapInf(0).biXPelsPerMeter = 0
    BitMapInf(0).biYPelsPerMeter = 0
    BitMapInf(0).biClrUsed = 0
    BitMapInf(0).biClrImportant = 0
    
    Select Case icotype16
    Case bits:
    BitMapInf(0).biBitCount = 1
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    Case nybs:
    BitMapInf(0).biBitCount = 4
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    Case bytes:
    BitMapInf(0).biBitCount = 8
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    End Select
Case 2  '2 32x32
    ReDim BitMapInf(0)
    BitMapInf(0).biSize = 40
    BitMapInf(0).biWidth = 32
    BitMapInf(0).biHeight = 64
    BitMapInf(0).biPlanes = 1
    BitMapInf(0).biCompression = 0
    BitMapInf(0).biXPelsPerMeter = 0
    BitMapInf(0).biYPelsPerMeter = 0
    BitMapInf(0).biClrUsed = 0
    BitMapInf(0).biClrImportant = 0
    
    Select Case icotype32
    Case bits:
    BitMapInf(0).biBitCount = 1
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    Case nybs:
    BitMapInf(0).biBitCount = 4
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    Case bytes:
    BitMapInf(0).biBitCount = 8
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    End Select
Case 3  '3 16x6 & 32x32
    ReDim BitMapInf(1)
    BitMapInf(0).biSize = 40
    BitMapInf(0).biWidth = 16
    BitMapInf(0).biHeight = 32
    BitMapInf(0).biPlanes = 1
    BitMapInf(0).biCompression = 0
    BitMapInf(0).biXPelsPerMeter = 0
    BitMapInf(0).biYPelsPerMeter = 0
    BitMapInf(0).biClrUsed = 0
    BitMapInf(0).biClrImportant = 0
    
    BitMapInf(1).biSize = 40
    BitMapInf(1).biWidth = 32
    BitMapInf(1).biHeight = 64
    BitMapInf(1).biPlanes = 1
    BitMapInf(1).biCompression = 0
    BitMapInf(1).biXPelsPerMeter = 0
    BitMapInf(1).biYPelsPerMeter = 0
    BitMapInf(1).biClrUsed = 0
    BitMapInf(1).biClrImportant = 0
    
    Select Case icotype16
    Case bits:
    BitMapInf(0).biBitCount = 1
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    Case nybs:
    BitMapInf(0).biBitCount = 4
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    Case bytes:
    BitMapInf(0).biBitCount = 8
    BitMapInf(0).biSizeImage = xorsize16 + andsize16
    End Select
    
    Select Case icotype32
    Case bits:
    BitMapInf(1).biBitCount = 1
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    Case nybs:
    BitMapInf(1).biBitCount = 4
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    Case bytes:
    BitMapInf(1).biBitCount = 8
    BitMapInf(0).biSizeImage = xorsize32 + andsize32
    End Select
End Select

'To clear any old binary bits in an existing file
Open CIBFile$ For Output As #1
Print #1, " ";
Close

Open CIBFile$ For Binary As #1
Put #1, , icocursig
'CulToRGB longcul&, RR$, GG$, BB$
'Global bluec, greenc, redc,
'Dim bzero As Byte, abyte As Byte
bzero = 0

Select Case IconParameter
Case 1  '1 16x16
    Put #1, , icocurspec(0): Put #1, , BitMapInf(0)
    Select Case icotype16
    Case bits:
        GoSub bitsculXOR16
        GoSub PutAND16
    Case nybs:
        GoSub nybsculXOR16
        GoSub PutAND16
    Case bytes:
        GoSub bytesculXOR16
        GoSub PutAND16
    End Select

Case 2  '2 32x32
    Put #1, , icocurspec(0): Put #1, , BitMapInf(0)
    Select Case icotype32
    Case bits:
        GoSub bitsculXOR32
        GoSub PutAND32
    Case nybs:
        GoSub nybsculXOR32
        GoSub PutAND32
    Case bytes:
        GoSub bytesculXOR32
        GoSub PutAND32
    End Select

Case 3  '3 16x6 & 32x32
    Put #1, , icocurspec(0)
    Put #1, , icocurspec(1)
    
    Select Case icotype16
    Case bits:
        Put #1, , BitMapInf(0)
        GoSub bitsculXOR16
        GoSub PutAND16
    Case nybs:
        Put #1, , BitMapInf(0)
        GoSub nybsculXOR16
        GoSub PutAND16
    Case bytes:
        Put #1, , BitMapInf(0)
        GoSub bytesculXOR16
        GoSub PutAND16
    End Select

    Select Case icotype32
    Case bits:
        Put #1, , BitMapInf(1)
        GoSub bitsculXOR32
        GoSub PutAND32
    Case nybs:
        Put #1, , BitMapInf(1)
        GoSub nybsculXOR32
        GoSub PutAND32
    Case bytes:
        Put #1, , BitMapInf(1)
        GoSub bytesculXOR32
        GoSub PutAND32
    End Select
End Select
Close #1
Exit Sub
'====================
bitsculXOR16:
For i = 0 To 1
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 abyte = 0
 For IX = 0 To 7
   If XOR16(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
 Next IX
 Put #1, , abyte
 abyte = 0
 For IX = 8 To 15
   If XOR16(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
 Next IX
 Put #1, , abyte
 
 'Make up to 4 bytes
 Put #1, , bzero
 Put #1, , bzero
 
Next IY
Return
'--------------
nybsculXOR16:
For i = 0 To 15
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 For IX = 0 To 14 Step 2
    hinyb = XOR16(IX, IY): If hinyb > 15 Then hinyb = 15
    lonyb = XOR16(IX + 1, IY): If lonyb > 15 Then lonyb = 15
    abyte = 16 * hinyb + lonyb
    Put #1, , abyte
 Next IX
Next IY
Return
'--------------
bytesculXOR16:
For i = 0 To 255
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 For IX = 0 To 15
  Put #1, , XOR16(IX, IY)
 Next IX
Next IY
Return
'--------------
bitsculXOR32:
For i = 0 To 1
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For ii = 0 To 3
  abyte = 0
  For IX = 8 * ii To 8 * ii + 7
   If XOR32(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
  Next IX
  Put #1, , abyte
 Next ii
Next IY
Return
'--------------
nybsculXOR32:
For i = 0 To 15
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For IX = 0 To 31 Step 2
   hinyb = XOR32(IX, IY): If hinyb > 15 Then hinyb = 15
   lonyb = XOR32(IX + 1, IY): If lonyb > 15 Then lonyb = 15
   abyte = 16 * hinyb + lonyb
    Put #1, , abyte
 Next IX
Next IY
Return
'--------------
bytesculXOR32:
For i = 0 To 255
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For IX = 0 To 31
  Put #1, , XOR32(IX, IY)
 Next IX
Next IY
Return
'--------------
PutAND16:
For IY = 15 To 0 Step -1
 For IX = 0 To 3
  Put #1, , AND16(IX, IY)
   na = na + 1
 Next IX
Next IY
Return
'--------------
PutAND32:
For IY = 31 To 0 Step -1
 For IX = 0 To 3
  Put #1, , AND32(IX, IY)
 Next IX
Next IY
Return
'--------------
End Sub

Public Sub SAVINGCURSOR(CIBFile$)
'NB Cursors can only be saved as 32x32 16 colors ie nybs
'Note icocursig & icocurspec are used.

Dim bzero As Byte, abyte As Byte

icocursig.dres = 0
icocursig.dtyp = 2
icocursig.dnum = 1
    
palsize32 = 64
xorsize32 = 512
andsize32 = 128

ReDim icocurspec(0)
icocurspec(0).iwidth = 32
icocurspec(0).iheight = 32
icocurspec(0).inumculs = 16

HotX = Val(Form1.txtHotX.Text)
HotY = Val(Form1.txtHotY.Text)
icocurspec(0).inumplanes = HotX
icocurspec(0).ibpp = HotY

icocurspec(0).iresize = 40 + palsize32 + xorsize32 + andsize32
icocurspec(0).ipointer = 6 + 16

ReDim BitMapInf(0)
BitMapInf(0).biSize = 40
BitMapInf(0).biWidth = 32
BitMapInf(0).biHeight = 64
BitMapInf(0).biPlanes = 1
BitMapInf(0).biBitCount = 4
BitMapInf(0).biCompression = 0
BitMapInf(0).biSizeImage = xorsize32 + andsize32
BitMapInf(0).biXPelsPerMeter = 0
BitMapInf(0).biYPelsPerMeter = 0
BitMapInf(0).biClrUsed = 0
BitMapInf(0).biClrImportant = 0

On Error GoTo CursorError
    
Open CIBFile$ For Output As #1
Print #1, " ";
Close

Open CIBFile$ For Binary As #1
Put #1, , icocursig
Put #1, , icocurspec(0)
Put #1, , BitMapInf(0)
'Put 16-color Pal
bzero = 0
For i = 0 To 15
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
'PutXOR32nybs
For IY = 31 To 0 Step -1
 For IX = 0 To 31 Step 2
   abyte = 16 * XOR32(IX, IY) + XOR32(IX + 1, IY)
   Put #1, , abyte
 Next IX
Next IY
'PutAND32
For IY = 31 To 0 Step -1
 For IX = 0 To 3
  Put #1, , AND32(IX, IY)
 Next IX
Next IY
Close
Exit Sub
CursorError:
Close
MsgBox ("Can only have 0-15 color numbers")

End Sub

Public Sub SAVINGBMPS(CIBFile$)
'NB Both 16x16 & 32x23 BMPS can be saved with all the palettes
'ie 2,16,256 or 24-bit

'Global BitMapFile As BITMAPFILEHEADER
'Global BitMapInf() As BITMAPINFOHEADER

ReDim BitMapInf(0)

'IconParameter 1 16x16,  2 32x32

Dim bzero As Byte, abyte As Byte
Dim bits As String, nybs As String, bytes As String, bits24 As String
Dim bmptype16  As String, bmptype32 As String

bits = "bits": nybs = "nybs": bytes = "bytes": bits24 = "24bits"

bmptype16 = bits24
If Form1.Option1(0) Then bmptype16 = bits
If Form1.Option1(1) Then bmptype16 = nybs
If Form1.Option1(2) Then bmptype16 = bytes
bmptype32 = bits24
If Form1.Option2(0) Then bmptype32 = bits
If Form1.Option2(1) Then bmptype32 = nybs
If Form1.Option2(2) Then bmptype32 = bytes

FileSize& = 14 + 40 'BITMAPFILEHEADER + BITMAPINFOHEADER

If IconParameter = 1 Then   '16x16
   bmpwidth = 16
   Select Case bmptype16
   Case bits
    palsize = 8
    xorsize = 64
    offset = 62
    bitcount = 1
   Case nybs
    palsize = 64
    xorsize = 128
    offset = 118
    bitcount = 4
   Case bytes
    palsize = 1024
    xorsize = 256
    offset = 1078
    bitcount = 8
   Case bits24
    palsize = 0
    xorsize = 16 * 16 * 3
    offset = 54
    bitcount = 24
   End Select
   FileSize& = FileSize& + palsize + xorsize

ElseIf IconParameter = 2 Then   '32x32
   bmpwidth = 32
   Select Case bmptype32
   Case bits
    palsize = 8
    xorsize = 128
    offset = 62
    bitcount = 1
   Case nybs
    palsize = 64
    xorsize = 512
    offset = 118
    bitcount = 4
   Case bytes
    palsize = 1024
    xorsize = 1024
    offset = 1078
    bitcount = 8
   Case bits24
    palsize = 0
    xorsize = 32 * 32 * 3
    offset = 54
    bitcount = 24
   End Select
   FileSize& = FileSize& + palsize + xorsize
End If

BitMapFile.bfType = 19778   'BM
BitMapFile.bfSize = FileSize&
BitMapFile.bfReserved1 = 0
BitMapFile.bfReserved2 = 0
BitMapFile.bfOffBits = offset

BitMapInf(0).biSize = 40
BitMapInf(0).biWidth = bmpwidth
BitMapInf(0).biHeight = BitMapInf(0).biWidth
BitMapInf(0).biPlanes = 1
BitMapInf(0).biBitCount = bitcount
BitMapInf(0).biCompression = 0
BitMapInf(0).biSizeImage = xorsize
BitMapInf(0).biXPelsPerMeter = 0
BitMapInf(0).biYPelsPerMeter = 0
BitMapInf(0).biClrUsed = 0
BitMapInf(0).biClrImportant = 0

Open CIBFile$ For Output As #1
Print #1, " ";
Close

Open CIBFile$ For Binary As #1
Put #1, , BitMapFile
Put #1, , BitMapInf(0)

Select Case IconParameter
Case 1  '1 16x16
    Select Case bmptype16
    Case bits:
        GoSub bitsculXOR16
    Case nybs:
        GoSub nybsculXOR16
    Case bytes:
        GoSub bytesculXOR16
    Case bits24
        GoSub bits24XOR16
    End Select

Case 2  '2 32x32
    Select Case bmptype32
    Case bits:
        GoSub bitsculXOR32
    Case nybs:
        GoSub nybsculXOR32
    Case bytes:
        GoSub bytesculXOR32
    Case bits24
        GoSub bits24XOR32
    End Select
End Select

Close #1
Exit Sub
'====================
bitsculXOR16:
For i = 0 To 1
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 abyte = 0
 For IX = 0 To 7
   If XOR16(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
 Next IX
 Put #1, , abyte
 abyte = 0
 For IX = 8 To 15
   If XOR16(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
 Next IX
 Put #1, , abyte
 
 'Make up to 4 bytes
' Put #1, , bzero
' Put #1, , bzero
 
Next IY
Return
'--------------
'--------------
nybsculXOR16:
For i = 0 To 15
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 For IX = 0 To 14 Step 2
   hinyb = XOR16(IX, IY): If hinyb > 15 Then hinyb = 15
   lonyb = XOR16(IX + 1, IY): If lonyb > 15 Then lonyb = 15
   abyte = 16 * hinyb + lonyb
   Put #1, , abyte
 Next IX
Next IY
Return
'--------------
bytesculXOR16:
For i = 0 To 255
 CulToRGBc Colors(i, 1)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 15 To 0 Step -1
 For IX = 0 To 15
  Put #1, , XOR16(IX, IY)
 Next IX
Next IY
Return
'--------------
bits24XOR16:
Form1.Show16BMP
For j = 15 To 0 Step -1
For i = 0 To 15
   cul& = Form1.picShow16.Point(i, j)
   Put #1, , bluec: Put #1, , greenc: Put #1, , redc
Next i
Next j
Return
'--------------
bitsculXOR32:
For i = 0 To 1
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For ii = 0 To 3
  abyte = 0
  For IX = 8 * ii To 8 * ii + 7
   If XOR32(IX, IY) <> 0 Then
    abyte = abyte + 1
   Else
    abyte = abyte * 2
   End If
  Next IX
  Put #1, , abyte
 Next ii
Next IY
Return
'--------------
nybsculXOR32:
For i = 0 To 15
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For IX = 0 To 31 Step 2
   hinyb = XOR32(IX, IY): If hinyb > 15 Then hinyb = 15
   lonyb = XOR32(IX + 1, IY): If lonyb > 15 Then lonyb = 15
   abyte = 16 * hinyb + lonyb
   Put #1, , abyte
 Next IX
Next IY
Return
'--------------
bytesculXOR32:
For i = 0 To 255
 CulToRGBc Colors(i, 2)
 Put #1, , bluec: Put #1, , greenc: Put #1, , redc: Put #1, , bzero
Next i
For IY = 31 To 0 Step -1
 For IX = 0 To 31
  Put #1, , XOR32(IX, IY)
 Next IX
Next IY
Return
'--------------
bits24XOR32:
Form1.Show32BMP
For j = 31 To 0 Step -1
For i = 0 To 31
   cul& = Form1.picShow32.Point(i, j)
   CulToRGBc cul&
   Put #1, , bluec: Put #1, , greenc: Put #1, , redc
Next i
Next j
Return
'--------------

End Sub
Public Sub FindNearestCul(longcul&, n, cn)
'Input: Longcul&, n= 1 for 16 2 for 32 Output Colour number cn
cnn = 1
CulToRGBc longcul&
redo = redc: greeno = greenc: blueo = bluec
diffcul = 10000
For mcn = 0 To 255
    CulToRGBc Colors(mcn, n)  'n= 1 or 2
    'redc, greenc, bluec,bzero As Bytes
    diffc = Abs(redc - redo) + Abs(greenc - greeno) + Abs(bluec - blueo)
    If diffc < diffcul Then
       cnn = mcn
       diffcul = diffc
       If diffc = 0 Then Exit For
    End If
Next mcn
cn = cnn
End Sub

Public Sub Blurr(nicon)
If nicon = 16 Then

Form1.Show16BMP
For j = 1 To 14
For i = 1 To 14
   cul& = Form1.picShow16.Point(i, j)
   CulToRGBc cul&
   sred = redc: sgreen = greenc: sblue = bluec
   cul& = Form1.picShow16.Point(i, j - 1)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow16.Point(i + 1, j)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow16.Point(i, j + 1)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow16.Point(i - 1, j)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   sred = sred \ 5: sgreen = sgreen \ 5: sblue = sblue \ 5
   
   FindNearestCul RGB(sred, sgreen, sblue), 1, cn
   
   XOR16(i, j) = cn
Next i
Next j
Form1.TransferXOR16topic16Icon

Else

Form1.Show32BMP
For j = 1 To 30
For i = 1 To 30
   cul& = Form1.picShow32.Point(i, j)
   CulToRGBc cul&
   sred = redc: sgreen = greenc: sblue = bluec
   cul& = Form1.picShow32.Point(i, j - 1)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow32.Point(i + 1, j)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow32.Point(i, j + 1)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   cul& = Form1.picShow32.Point(i - 1, j)
   CulToRGBc cul&
   sred = sred + redc: sgreen = sgreen + greenc: sblue = sblue + bluec
   sred = sred \ 5: sgreen = sgreen \ 5: sblue = sblue \ 5
   
   FindNearestCul RGB(sred, sgreen, sblue), 2, cn
   
   XOR32(i, j) = cn
Next i
Next j
Form1.TransferXOR32topic32Icon

End If
End Sub

Public Sub Darken(nicon)
Select Case nicon
Case 16
   For n = 0 To 255
      cul& = Colors(n, 1)
      If cul& <> 0 Then
         CulToRGBc cul&   'redc,greenc,bluec
         sred = redc - 5: If sred < 0 Then sred = 0
         sgreen = greenc - 5: If sgreen < 0 Then sgreen = 0
         sblue = bluec - 5: If sblue < 0 Then sblue = 0
         Colors(n, 1) = RGB(sred, sgreen, sblue)
      End If
   Next n
   Form1.FillpicPAL16
Case 32
   For n = 0 To 255
      cul& = Colors(n, 2)
      If cul& <> 0 Then
         CulToRGBc cul&   'redc,greenc,bluec
         sred = redc - 5: If sred < 0 Then sred = 0
         sgreen = greenc - 5: If sgreen < 0 Then sgreen = 0
         sblue = bluec - 5: If sblue < 0 Then sblue = 0
         Colors(n, 2) = RGB(sred, sgreen, sblue)
      End If
   Next n
   Form1.FillpicPAL32
End Select
End Sub
Public Sub Brighten(nicon, prgb)
'prgb =0 all, 1 red, 2 green, 3 blue
Select Case nicon
Case 16
   For n = 0 To 255
      cul& = Colors(n, 1)
      If cul& <> 0 Then
         CulToRGBc cul&   'redc,greenc,bluec
         sred = redc
         sgreen = greenc
         sblue = bluec
         Select Case prgb
         Case 0
         sred = redc + 5: If sred > 255 Then sred = 255
         sgreen = greenc + 5: If sgreen > 255 Then sgreen = 255
         sblue = bluec + 5: If sblue > 255 Then sblue = 255
         Case 1
         sred = redc + 5: If sred > 255 Then sred = 255
         Case 2
         sgreen = greenc + 5: If sgreen > 255 Then sgreen = 255
         Case 3
         sblue = bluec + 5: If sblue > 255 Then sblue = 255
         End Select
         Colors(n, 1) = RGB(sred, sgreen, sblue)
      End If
   Next n
   Form1.FillpicPAL16
Case 32
   For n = 0 To 255
      cul& = Colors(n, 2)
      If cul& <> 0 Then
         CulToRGBc cul&   'redc,greenc,bluec
         sred = redc
         sgreen = greenc
         sblue = bluec
         Select Case prgb
         Case 0
         sred = redc + 5: If sred > 255 Then sred = 255
         sgreen = greenc + 5: If sgreen > 255 Then sgreen = 255
         sblue = bluec + 5: If sblue > 255 Then sblue = 255
         Case 1
         sred = redc + 5: If sred > 255 Then sred = 255
         Case 2
         sgreen = greenc + 5: If sgreen > 255 Then sgreen = 255
         Case 3
         sblue = bluec + 5: If sblue > 255 Then sblue = 255
         End Select
         Colors(n, 2) = RGB(sred, sgreen, sblue)
      End If
   Next n
   Form1.FillpicPAL32
End Select
End Sub

Public Sub ReflectLR(nicon)
Dim tbyte As Byte
If nicon = 16 Then
   For j = 0 To 15
   For i = 0 To 7
      tbyte = XOR16(i, j)
      XOR16(i, j) = XOR16(15 - i, j)
      XOR16(15 - i, j) = tbyte
   Next i
   Next j
   Form1.TransferXOR16topic16Icon
Else  'nicon=32
   For j = 0 To 31
   For i = 0 To 15
      tbyte = XOR32(i, j)
      XOR32(i, j) = XOR32(31 - i, j)
      XOR32(31 - i, j) = tbyte
   Next i
   Next j
   Form1.TransferXOR32topic32Icon
End If

End Sub
Public Sub ReflectUD(nicon)
Dim tbyte As Byte
If nicon = 16 Then
   For i = 0 To 15
   For j = 0 To 7
      tbyte = XOR16(i, j)
      XOR16(i, j) = XOR16(i, 15 - j)
      XOR16(i, 15 - j) = tbyte
   Next j
   Next i
   Form1.TransferXOR16topic16Icon
Else  'nicon=32
   For i = 0 To 31
   For j = 0 To 15
      tbyte = XOR32(i, j)
      XOR32(i, j) = XOR32(i, 31 - j)
      XOR32(i, 31 - j) = tbyte
   Next j
   Next i
   Form1.TransferXOR32topic32Icon
End If

End Sub
Public Sub Rotate90(nicon)
If nicon = 16 Then
ReDim tbyte(0 To 15, 0 To 15) As Byte
   For j = 0 To 15
   For i = 0 To 15
      ii = 15 - j
      jj = i
      tbyte(ii, jj) = XOR16(i, j)
   Next i
   Next j
   CopyMemory XOR16(0, 0), tbyte(0, 0), 256
   Form1.TransferXOR16topic16Icon
Else  'nicon=32
ReDim tbyte(0 To 31, 0 To 31) As Byte
   For j = 0 To 31
   For i = 0 To 31
      ii = 31 - j
      jj = i
      tbyte(ii, jj) = XOR32(i, j)
   Next i
   Next j
   CopyMemory XOR32(0, 0), tbyte(0, 0), 1024
   Form1.TransferXOR32topic32Icon
End If
Erase tbyte
End Sub
Public Sub CopyXOR2XOR(nicon)
If nicon = 16 Then   'Copy XOR16 to XOR32
   For j = 0 To 15
   For i = 0 To 15
      XOR32(2 * i, 2 * j) = XOR16(i, j)
      XOR32(2 * i + 1, 2 * j) = XOR16(i, j)
      XOR32(2 * i, 2 * j + 1) = XOR16(i, j)
      XOR32(2 * i + 1, 2 * j + 1) = XOR16(i, j)
   Next i
   Next j
   CopyMemory Colors(0, 2), Colors(0, 1), 1024
   Form1.FillpicPAL32
   Form1.TransferXOR32topic32Icon
Else     'Copy XOR32 to XOR16
   For j = 0 To 31 Step 2
   For i = 0 To 31 Step 2
      XOR16(i \ 2, j \ 2) = XOR32(i, j)
   Next i
   Next j
   CopyMemory Colors(0, 1), Colors(0, 2), 1024
   Form1.FillpicPAL16
   Form1.TransferXOR16topic16Icon
End If
End Sub

Public Sub Remap(nicon)
If nicon = 16 Then
   Form1.TransferXOR16topic16Icon   'using Colors(n,1)
Else  'nicon=32
   Form1.TransferXOR32topic32Icon   'using Colors(n,2)
End If
End Sub

Public Sub SAVEPAL(CIBFile$)
'IconParameter 1 16x16, 2 32x32

icotype16 = bytes 'Assume Option1(6) True
If Form1.Option1(4) Then icotype16 = bits
If Form1.Option1(5) Then icotype16 = nybs
icotype32 = bytes 'Assume Option2(6) True
If Form1.Option2(4) Then icotype32 = bits
If Form1.Option2(5) Then icotype32 = nybs

Select Case IconParameter
'Test PAL color range as ICON set
Case 1  '16x16
If Form1.Option1(3) Then numculs = 2
If Form1.Option1(4) Then numculs = 16
If Form1.Option1(5) Then numculs = 256
Case 2
If Form1.Option2(3) Then numculs = 2
If Form1.Option2(4) Then numculs = 16
If Form1.Option2(5) Then numculs = 256
End Select

Open CIBFile$ For Output As #1
Print #1, "JASC-PAL"
Print #1, "0100"
Print #1, Trim$(Str$(numculs))
For n = 0 To numculs - 1
   CulToRGB Colors(n, IconParameter), RR$, GG$, BB$
   Print #1, RR$; " "; GG$; " "; BB$
Next n
Close
End Sub
